/*----  FanContr1.0----*/
//    ATtiny13-20PI  DS18S20  DS18B20
// : WinAVR-20060125
//Make: Name=FanContr,MCU=ATtiny13,Level=2,Debug=VMLab,Programmer=ponyser,Port=com1
/* : CKSEL1=0 (Ft=4,8);
            BODLEVEL0=BODLEVEL1=0 ( BOD   U=4,3);
            SUT0=SUT1=0 (    RESET - 14 );
            SPIEN=1 (0- SPI prog ,  -1);
            CKDIV8=1 !!! (    8 (CLKPS3=CLKPS2=CLKPS1=CLKPS0=0));
            WDTON=0 (  );
            (0-> )
              Calibration Byte=5Fh*/
/* RC- 5,0 */
# include <avr/io.h>                //  
#include <avr/wdt.h>                //    
# define Tmin 30                    //    
# define Tmax 45                    //     
# define Uref 1240                  //  AP432  
# define Up 5000                    //    
# define Umin 8000                  //     
# define Umax 12000                 //     
# define RED PORTB1                 // 1 -   
# define GREEN PORTB2               // 2 -   
# define PORT_1w PORTB              //  ,   1-wire (PORTB)
# define DDR_1w DDRB                //  DDR ,   1-wire
# define PIN_1w PINB                //  ,   1-wire
# define P_1w PB3                   //  ,   1-wire (PB3-.2)
# define dU (Umax-Umin)/(Tmax-Tmin) //     1
//
/*----  ----*/
unsigned char rezh=0;               // : 0-,1-
unsigned char Temp=20;              //   
unsigned char dat=0;                //   (1- )
//
/*----  ----*/
void indikat (void);                // 
void izmtemp (void);                //  
void speed (void);                  //    
unsigned char init_1w (void);       //  DS18x20 (  -  1)
unsigned char readbit (void);       //   1-wire
unsigned char read_1w (void);       //   1-wire
void wrbit0 (void);                 //  0  1-wire
void wrbit1 (void);                 //  1  1-wire
void write_1w (unsigned char b);    //   1-wire
void tayus (unsigned char t);       //     (2...255)
void tayms (unsigned int t);        //     (1...65535)
//
/*---- ----*/
int main (void)
{ DDRB=0x07;                        //00000111 PB0-PB2 , PB3-PB5 - 
  PORTB=0x30;                       //00110000 PB0=PB1=PB2=PB3=0, PB4,PB5 -   
  ACSR=0x80;                        //  
  CLKPR=0x80;                       // . F. (   CKDIV8)
  CLKPR=0x00;                       // =1 (   CKDIV8)
  OSCCAL=OSCCAL+3;                  // .  4,8  5  (Figure 120 DataSheet ATtiny13)
  wdt_reset();                      //    
  wdt_enable(WDTO_2S);              //      2 .
  while(1)                          // 
  { izmtemp();                      // 
    wdt_reset();                    //  
    speed();                        //   
    indikat();                      //
  }
}
/*----  ----*/
void izmtemp (void)
{ unsigned char z;                  //    DS18x20
  unsigned char byte0;              //.   
  unsigned char byte1;              //.   
  dat=1;                            //   
  if (init_1w()==0)                 //  DS18x20  
  { dat=0;                          //  
    goto Mig;                       //3   
  }
  write_1w(0x33);                   //  Read ROM ( ) 33h
  z=read_1w();                      //   -  
  if ((z!=0x10)&&(z!=0x28))         //    DS18S20 (10h)  DS18B20 (28h)
  { dat=0;                          //   
Mig:                                //  
    z=3;                            //3   
    while (z>0)
    { PORTB&=~_BV(GREEN);           //  
      PORTB|=_BV(RED);              //  
      tayms(300);                   //  
      PORTB&=~_BV(GREEN);           //  
      PORTB&=~_BV(RED);             //  
      tayms(300);                   //  
      z--;
      wdt_reset();                  //  
    }
    tayms(1000);                    // 1 .
    wdt_reset();                    //  
    return;
  }
  if (init_1w()==0)                 //  DS18x20  
  { dat=0;                          //  
    return;
  }
  write_1w(0xCC);                   //  Skip ROM ( 
                                    //  ) CCh
  write_1w(0x44);                   //  Convert T ( 
                                    // ) 44h
  tayms(750);                       //  750    
  if (init_1w()==0)                 //  DS18x20  
  { dat=0;                          //  
    return;
  }
  write_1w(0xCC);                   //  Skip ROM ( 
                                    //  ) CCh
  write_1w(0xBE);                   //  Read Scratchpad (
                                    //   ) BEh
  byte0=read_1w();                  //   
  byte1=read_1w();                  //    ()
//  
  if (z==0x10)                      //  DS18S20
  { if (byte1==0)                   //  >=0
    { Temp=(byte0>>1);              //     
    }
    else Temp=0;                    //,  t<0,  Temp=0
  }
  else                              //
  if (z==0x28)                      //  DS18B20
  { if (byte1>=0b11110000)          //  >=0
    { Temp=0;                       //Temp=0
    }
    else Temp=(byte1<<4)|(byte0>>4);//      
  }
  return;
}
/*----    ----*/
void speed (void)                   //    OC0A(PB1): 5 /256=19,53 
{ char dT=(Temp-Tmin);              //    
  unsigned long a;                  // 
  unsigned char b;                  // 
  unsigned int Ufan=0;              //    
  unsigned int Uout=0;              //    ( )  
  if (dat==1)                       //   
  { if (rezh==0)                    //   
    { if (Temp<Tmin) return;        //  <Tmin - 
      rezh=1;                       //   
      Ufan=10000;                   //   = 10
    }
    else                            //     (rezh=1)
    { if (Temp<(Tmin-1))            //.<(Tmin-1) (   2)
      { rezh=0;                     //  
        TCCR0B=0x00;                //00000000 - ..0 ,  
        TCCR0A=0x03;                //00000011 -  FastPWM  
        return;
      }
      else
      { if (Temp<=Tmin)             //(Tmin-1)<Temp<=Tmin
        { Ufan=Umin;                //   - 
        }
        else
        { if (Temp<Tmax)            //   Tmax
          { Ufan=dT*dU+Umin;        //   (Ufan=dT*dU+Umin)
          }
          else Ufan=Umax;           //  >= Tmax
        }
      }
    }
    Uout=Uref+(Ufan/4);             //      (Uout=Uref+Ufan/Kdel)
    a=Uout+50;                      //     R      unsigned int  unsigned long
    a=((a*256)/Up)-1;               //  (OCR0A=256*Uout/Up-1)
    b=a;                            //    unsigned long  unsigned char
    OCR0A=b;                        //  
    TCCR0A=0x83;                    //10000011 - FastPWM (.) (F=5/255=19,6 )
    TCCR0B=1;                       //00000001 -  ..0,  -  
  }
  else                              //,     
  { rezh=0;                         //  
    TCCR0B=0x00;                    //00000000 - ..0 ,  
    TCCR0A=0x03;                    //00000011 -  FastPWM  
  }
  return;
}
/*---- ----*/
void indikat (void)
{ if (dat==0)                       //    DS18x20
  { PORTB&=~_BV(GREEN);             //  
    PORTB&=~_BV(RED);               //  
  }
  else
  { if (rezh==0)                    //  
    { PORTB|=_BV(GREEN);            //  
      PORTB&=~_BV(RED);             //  
    }
    else                            //,   
    { if (Temp<Tmax)                //     
      { PORTB|=_BV(GREEN);          //   |
                                    //                               >   
        PORTB|=_BV(RED);            //   |
      }
      else                          // -  >= Tmax
      { PORTB&=~_BV(GREEN);         //  
        PORTB|=_BV(RED);            //  
      }
    }
  }
  return;
}
//
/*----    ----*/
void tayus (unsigned char t)        // (2...255) 
{ if (t>2)
  { t=t-3;                          //
    while (t>0)
    { asm("nop");                   // 1  - 200  (F=5)
      t--;
    }
  }
  return;                           //  = t+0,2 
}
//
/*----    ----*/
void tayms (unsigned int t)         //(1...65535) 
{ unsigned int t1;
  while (t!=0)
  { t1=4993;
    while (--t1!=0);
    t--;
  }
  return;
}
//
//---------------------------------------------------------------
//=============== 1-wire (174 bytes)====================
//---------------------------------------------------------------
/*----  DS18x20----*/
unsigned char init_1w (void)        //  -  1
{ DDR_1w|=_BV(P_1w);                // P_1w -  ,   0
  tayus(250); tayus(250);           //  >480 
  DDR_1w&=~_BV(P_1w);               // P_1w -     ..(  1)
  tayus(60);                        //  15-60 
  if (bit_is_clear(PIN_1w,P_1w))    //   0 -  DS1820
  { tayus(240);                     //  240     DS1820
    return(1);                      //  1 - 
  }
  tayms(250);                       //     - 4 .  .
  return(0);                        // -   0 (   DS1820)
}
//
/*----  0  1-wire----*/
void wrbit0 (void)
{ DDR_1w|=_BV(P_1w);                // P_1w -  ,   0
  tayus(120);                       //  60-120 
  DDR_1w&=~_BV(P_1w);               // P_1w -     ..(  1)
  tayus(6);                         //   1   >1
  return;
}
//
/*----  1  1-wire----*/
void wrbit1 (void)
{ DDR_1w|=_BV(P_1w);                // P_1w -  ,   0
  tayus(6);                         //  1-15 
  DDR_1w&=~_BV(P_1w);               // P_1w -     ..(  1)
  tayus(114);                       //   120 
  return;
}
//
/*----   1-wire----*/
unsigned char readbit (void)
{ unsigned char bit=0;              //    
  DDR_1w|=_BV(P_1w);                // P_1w -  ,   0
  tayus(4);                         //  1-15 
  DDR_1w&=~_BV(P_1w);               // P_1w -     ..(  1)
  tayus(8);                         //   <15 
  if (bit_is_set(PIN_1w,P_1w)) bit=1;//  1 -   bit  1
  tayus(48);                        //   60 
  return(bit);                      //  i
}
//
/*----   1-wire----*/
void write_1w (unsigned char byte)
{ unsigned char c;                  //   
  for(c=0; c<8; c++)                //  ,   
  { if (byte&_BV(0))                //  (0-)   1 (byte&&0x01==1)
    wrbit1();                       // 1 
    else wrbit0();                  // -  0 
    byte>>=1;                       //   
  }
  tayus(50);                        //    
  return;
}
//
/*----   1-wire----*/
unsigned char read_1w (void)
{ unsigned char c, r, read_byte;    // 
  for(c=0, r=1, read_byte=0; c<8; c++)//  ,   
  { if (readbit()) read_byte|=r;    //  =1 read_byte=read_byte|r
    r<<=1;                          //   
  }
  return(read_byte);
}
//--------------------------------------------------------------------------------------
/*
Program:   966 bytes (94.3% Full)  (1024 bytes .)
(.text + .data + .bootloader)

Data:        4 bytes (6.3% Full)  (64 bytes .)
(.data + .bss + .noinit)
*/
